# ACM SIGMOD Programming Contest 2023

## Team Info

Team name : RimTeam

Members:

| name         | institution       | email               |
| ------------ | ----------------- | ------------------- |
| Shuo Yang    | Xidian University | syang_xd@163.com    |
| Feifan Du    | Xidian University | smrilmax@163.com    |
| Chaowei Song | Xidian University | chwsong@foxmail.com |

## Description

Our method is based on [KGraph](https://github.com/aaalgo/kgraph). In data processing, we use interval mapping to convert the float data type to unsigned short for faster access later. And we use unsigned int to represent the Euclidean distance. Additionally, we use reservoir sampling to avoid situations where rnn_new and rnn_old consume too much memory. Finally, we choose better parameters to get higher recall.

- [Dong W, Moses C, Li K. Efficient k-nearest neighbor graph construction for generic similarity measures[C]//Proceedings of the 20th international conference on World wide web. 2011: 577-586.](https://dl.acm.org/doi/pdf/10.1145/1963405.1963487)

## Execution

First of all, you should modify the path of the dataset after "-source" in run.sh. Then you need to execute the following command, and you can get output.bin within the same directory.

```
bash ./run.sh
```

