#include <vector>
#include "VectorOracle.h"
#include "kgraph.h"
#include <stdlib.h>
using namespace std;
using namespace kgraph;

int main(int argc, char **argv) {
    string source_path = "dummy-data.bin";
    char *ptr;
    Matrix<unsigned short> data;
    KGraph::IndexParams params;
    for (int i = 0; i < argc; i++) {
        string arg = argv[i];
        if (arg == "-source") source_path = string(argv[i + 1]);
        if (arg == "-L") params.L = (unsigned)strtoul(argv[i + 1],&ptr,10);
        if (arg == "-S") params.S = (unsigned)strtoul(argv[i + 1],&ptr,10);
        if (arg == "-R") params.R = (unsigned)strtoul(argv[i + 1],&ptr,10);
    }
    std::cout<<"L="<<params.L<<"  S="<<params.S<<"  R="<<params.R<<std::endl;
    data.load_int(source_path);
    MatrixOracle<unsigned short> oracle(data);
    oracle.test();
    KGraph::IndexInfo info;
    KGraph *kgraph = KGraph::create(); //(oracle, params, &info);
    kgraph->build(oracle, params, &info,"output.bin");
    delete kgraph;
    
    /*
    Matrix<float> data;
    data.load(source_path);
    MatrixOracle<float> oracle(data);
    KGraph::IndexParams params;
    KGraph::IndexInfo info;
    KGraph *kgraph = KGraph::create(); //(oracle, params, &info);
    kgraph->build(oracle, params, &info);
    kgraph->save("output.bin");
    delete kgraph;
    */
    return 0;
}